]> git.saurik.com Git - bison.git/blob - bootstrap
e0de221a58852b159a8538e12675c37a3e898b59
[bison.git] / bootstrap
1 #! /bin/sh
2
3 # Bootstrap this package from CVS.
4
5 # Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2, or (at your option)
10 # any later version.
11
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
16
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20 # 02110-1301, USA.
21
22 # Written by Paul Eggert.
23
24 package=bison
25
26 # Translation Project URL, for the registry of all projects.
27 TP_URL='http://www.iro.umontreal.ca/translation/registry.cgi?domain='
28
29 # Ensure file names are sorted consistently across platforms;
30 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
31 # Also, ensure diagnostics are in English, e.g., "wget --help" below.
32 LC_ALL=C
33 export LC_ALL
34
35 # Parse options.
36
37 for option
38 do
39 case $option in
40 --help)
41 echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
42 exit;;
43 --gnulib-srcdir=*)
44 GNULIB_SRCDIR=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
45 --cvs-user=*)
46 CVS_USER=`expr "$option" : '--cvs-user=\(.*\)'`;;
47 --skip-po)
48 SKIP_PO=t;;
49 *)
50 echo >&2 "$0: $option: unknown option"
51 exit 1;;
52 esac
53 done
54
55 echo "$0: Bootstrapping CVS $package..."
56
57 cleanup_gnulib() {
58 status=$?
59 rm -fr gnulib
60 exit $status
61 }
62
63 # Get gnulib files.
64
65 case ${GNULIB_SRCDIR--} in
66 -)
67 if [ ! -d gnulib ]; then
68 echo "$0: getting gnulib files..."
69
70 case ${CVS_AUTH-pserver} in
71 pserver)
72 CVS_PREFIX=':pserver:anonymous@';;
73 ssh)
74 CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
75 *)
76 echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
77 exit 1;;
78 esac
79
80 case $CVS_RSH in
81 '') export CVS_RSH=ssh;;
82 esac
83
84 trap cleanup_gnulib 1 2 13 15
85
86 cvs -z3 -q -d ${CVS_PREFIX}cvs.savannah.gnu.org:/cvsroot/gnulib co gnulib ||
87 cleanup_gnulib
88
89 trap - 1 2 13 15
90 fi
91 GNULIB_SRCDIR=gnulib
92 esac
93
94 <$GNULIB_SRCDIR/gnulib-tool || exit
95 gnulib_tool="$GNULIB_SRCDIR/gnulib-tool --assume-autoconf=latest-stable"
96
97 gnulib_modules='
98 argmatch
99 dirname
100 error
101 extensions
102 getopt
103 gettext
104 hard-locale
105 hash
106 malloc
107 mbswidth
108 obstack
109 quote
110 quotearg
111 stdbool
112 stdio-safer
113 stdint
114 stpcpy
115 strerror
116 strtoul
117 strverscmp
118 unistd-safer
119 unlocked-io
120 verify
121 xalloc
122 xalloc-die
123 xstrndup
124 '
125
126 previous_gnulib_modules=
127 while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
128 previous_gnulib_modules=$gnulib_modules
129 gnulib_modules=`
130 (echo "$gnulib_modules"
131 for gnulib_module in $gnulib_modules; do
132 $gnulib_tool --extract-dependencies $gnulib_module
133 done) | sort -u
134 `
135 done
136
137 gnulib_files=`
138 (for gnulib_module in $gnulib_modules; do
139 $gnulib_tool --extract-filelist $gnulib_module
140 done) | sort -u
141 `
142
143 gnulib_dirs=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
144 mkdir -p $gnulib_dirs || exit
145
146 for gnulib_file in $gnulib_files; do
147 dest=$gnulib_file
148
149 case $gnulib_file in
150 # These will be overwritten by autopoint, which still uses
151 # old jm_.* macro names, so we have to keep both copies.
152 # m4/gettext.m4 isn't mentioned here, since it's patched below.
153 m4/glibc21.m4 | m4/inttypes_h.m4 | m4/lib-ld.m4 | \
154 m4/lib-prefix.m4 | m4/po.m4 | m4/stdint_h.m4 | m4/uintmax_t.m4 | \
155 m4/ulonglong.m4)
156 dest=`expr $gnulib_file : '\(.*\).m4'`_gl.m4;;
157 esac
158
159 rm -f $dest &&
160 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
161 cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
162 done
163
164 # This suppresses a bogus diagnostic
165 # "warning: macro `AM_LANGINFO_CODESET' not found in library".
166 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
167 sed '
168 /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
169 AC_DEFUN([AM_INTL_SUBDIR], [])
170 ' m4/gettext.m4 >m4/gettext_gl.m4 || exit
171
172
173 # Get translations.
174
175 get_translations() {
176 subdir=$1
177 domain=$2
178
179 echo "$0: getting translations into $subdir for $domain..."
180 (cd $subdir && rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'`) &&
181
182 $WGET_COMMAND -O "$subdir/$domain.html" "$TP_URL$domain" &&
183
184 sed -n 's|.*"http://[^"]*/translation/teams/PO/\([^/"]*\)/'"$domain"'-\([^/"]*\)\.[^."]*\.po".*|\1.\2|p' <"$subdir/$domain.html" |
185 sort -k 1,1 -k 2,2n -k2,2 -k3,3n -k3,3 -k4,4n -k4,4 -k5,5n -k5.5 |
186 awk -F. '
187 { if (lang && $1 != lang) print lang, ver }
188 { lang = $1; ver = substr($0, index($0, ".") + 1) }
189 END { if (lang) print lang, ver }
190 ' | awk -v domain="$domain" -v subdir="$subdir" '
191 {
192 lang = $1
193 ver = $2
194 urlfmt = ""
195 printf "$WGET_COMMAND -O %s/%s.po 'http://www.iro.umontreal.ca/translation/teams/PO/%s/%s-%s.%s.po' &&\n", subdir, lang, lang, domain, ver, lang
196 }
197 END { print ":" }
198 ' | sh &&
199 ls "$subdir"/*.po | sed 's|.*/||; s|\.po$||' >"$subdir/LINGUAS" &&
200 rm "$subdir/$domain.html"
201 }
202
203 case $SKIP_PO in
204 '')
205 case `wget --help` in
206 *'--no-cache'*)
207 no_cache='--no-cache';;
208 *'--cache=on/off'*)
209 no_cache='--cache=off';;
210 *)
211 no_cache='';;
212 esac
213
214 WGET_COMMAND="wget -nv $no_cache"
215 export WGET_COMMAND
216
217 get_translations po $package || exit
218
219 case $package in
220 bison)
221 get_translations runtime-po $package-runtime || exit
222 esac;;
223 esac
224
225
226 # Generate autoconf and automake snippets.
227
228 (echo '# This file is generated automatically by "bootstrap".' &&
229 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
230 $gnulib_tool --extract-autoconf-snippet $gnulib_modules &&
231 echo '])'
232 ) >m4/gnulib.m4 || exit
233
234 (echo '# This file is generated automatically by "bootstrap".' &&
235 $gnulib_tool --extract-automake-snippet $gnulib_modules |
236 sed 's/^[ ]*AM_CPPFLAGS[ ]*+=/# (commented out by bootstrap) &/'
237 ) >lib/gnulib.mk || exit
238
239
240 # Reconfigure, getting other files.
241
242 echo "$0: autoreconf --verbose --install --force ..."
243 autoreconf --verbose --install --force || exit
244
245
246 # We don't need intl, so remove it.
247 # Remove aclocal.m4 too, so that it gets rebuilt.
248 intl_files_to_remove='
249 aclocal.m4
250 intl
251 m4/codeset.m4
252 m4/gettext.m4
253 m4/glibc2.m4
254 m4/glibc21.m4
255 m4/intdiv0.m4
256 m4/intmax.m4
257 m4/inttypes_h.m4
258 m4/inttypes.m4
259 m4/inttypes-pri.m4
260 m4/isc-posix.m4
261 m4/lcmessage.m4
262 m4/lib-ld.m4
263 m4/lib-prefix.m4
264 m4/longdouble.m4
265 m4/po.m4
266 m4/printf-posix.m4
267 m4/signed.m4
268 m4/size_max.m4
269 m4/stdint_h.m4
270 m4/uintmax_t.m4
271 m4/ulonglong.m4
272 m4/wint_t.m4
273 m4/xsize.m4
274 '
275 echo $0: rm -fr $intl_files_to_remove ...
276 rm -fr $intl_files_to_remove || exit
277
278 # Undo changes to gnulib files that autoreconf made.
279 for gnulib_file in $gnulib_files; do
280 test ! -f $gnulib_file || cmp -s $gnulib_file $GNULIB_SRCDIR/$gnulib_file || {
281 rm -f $gnulib_file &&
282 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file again" &&
283 cp -p $GNULIB_SRCDIR/$gnulib_file $gnulib_file || exit
284 }
285 done
286
287 # Put bug-reporting address into po/Makevars.
288 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
289 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
290
291 # Likewise for runtime-po/Makevars, except also change a few other parameters.
292 sed '
293 s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
294 s/^\(subdir\) *=.*/\1 = runtime-po/
295 s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
296 ' <po/Makevars >runtime-po/Makevars
297
298 # Append 'datarootdir = $(prefix)/share' to po/Makefile.in.in to work
299 # around an incompatibility between Autoconf 2.60 and gettext 0.14.6.
300 # This hack can be removed once we assume gettext 0.15 or later.
301 grep datarootdir po/Makefile.in.in >/dev/null ||
302 echo 'datarootdir = @datarootdir@' >>po/Makefile.in.in
303
304 # Copy identical files from po to runtime-po.
305 (cd po && cp -p Makefile.in.in *-quot *.header *.sed *.sin ../runtime-po)
306
307 # if src/parse-gram.[ch] are out of date, rebuild them.
308 parse_gram_y=`find src/parse-gram.y \
309 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
310 -print` || exit
311 case $parse_gram_y in
312 ?*)
313 echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."
314
315 echo "$0: touch -c src/parse-gram.[ch] ... "
316 touch -c src/parse-gram.[ch] || exit
317
318 echo "$0: ./configure --disable-nls ..."
319 ./configure --disable-nls || exit
320
321 echo "$0: (cd lib && make) ..."
322 (cd lib && make) || exit
323
324 echo "$0: (cd src && make) ..."
325 (cd src && make) || exit
326
327 echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
328 rm -f src/parse-gram.c src/parse-gram.h || exit
329
330 echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
331 (cd src && make parse-gram.c parse-gram.h) || exit
332
333 echo "$0: make distclean ..."
334 make distclean || exit;;
335 esac
336
337 echo "$0: done. Now you can run './configure'."